#!/usr/bin/env python
#-*- coding:utf-8 -*-
#############################################################################
#Copyright (c): 2012-2019, Huawei Tech. Co., Ltd.
#FileName     : Result.py
#Version      : Gauss200 
#Date         : 2017-12-16
#Description  : Result.py is a utility to store search result from database
#############################################################################
try:
    import os
    import sys
    from ctypes import *
    sys.path.append(sys.path[0] + "/../../")
    from gspylib.common.Common import DefaultValue
except ImportError, e:
    sys.exit("[GAUSS-52200] : Unable to import module: %s." % str(e))
    
class sqlResult():
    """
    Class for storing search result from database
    """
    def __init__(self,result): 
        """
        Constructor
        """
        self.resCount = 0
        self.resSet = []
        self.result =  result
        
    def parseResult(self):    
        """
        function : get resCount and resSet from result
        input:NA
        output:NA
        """
        try:
            libpath = os.path.join(DefaultValue.getEnv("GAUSSHOME"), "lib")
            sys.path.append(libpath)
            libc = cdll.LoadLibrary("libpq.so.5.5")
            libc.PQntuples.argtypes = [c_void_p]
            libc.PQntuples.restype = c_int
            libc.PQnfields.argtypes = [c_void_p]
            libc.PQnfields.restype = c_int
            libc.PQgetvalue.restype = c_char_p
            ntups=libc.PQntuples(self.result)
            nfields=libc.PQnfields(self.result)
            libc.PQgetvalue.argtypes = [c_void_p, c_int, c_int]
            self.resCount =  ntups
            for i in range(ntups):
                tmpString = []
                for j in range(nfields):
                    paramValue = libc.PQgetvalue(self.result, i, j)
                    if(paramValue != None):
                        tmpString.append(string_at(paramValue))
                    else:
                        tmpString.append("")
                self.resSet.append(tmpString)    
        except Exception, e:
            raise Exception("%s" % str(e))         
            