#!/usr/bin/env python
#-*- coding:utf-8 -*-
#############################################################################
#Copyright (c): 2010-2020, Huawei Tech. Co., Ltd.
#FileName     : gsmemory.py
#Version      : Gauss200 
#Date         : 2018-03-26
#Description  : memory.py is a utility to do something for memory information.
#############################################################################
try:
    import sys
    import psutil
    sys.path.append(sys.path[0] + "/../../")
    from gspylib.common.ErrorCode import ErrorCode
except ImportError, e:
    sys.exit("[GAUSS-52200] : Unable to import module: %s." % str(e))

"""
Requirements:
get memory and swap size
"""
class memoryInfo(object):
    """
    function: Init the MemInfo options
    """
    def __init__(self):
        """
        function: Init the MemInfo options
        """
    @staticmethod
    def getMemUsedSize():
        """
        get used memory size
        """
        return psutil.virtual_memory().used

    @staticmethod
    def getMemFreeSize():
        """
        get free memory size
        """
        return psutil.virtual_memory().free

    @staticmethod
    def getSwapUsedSize():
        """
        get used swap size
        """
        return psutil.swap_memory().used

    @staticmethod
    def getSwapFreeSize():
        """
        get free swap size
        """
        return psutil.swap_memory().free

    @staticmethod
    def getSwapTotalSize():
        """
        function : Get swap memory total size
        input  : null
        output : total  memory size (byte)
        """
        total = 0
        try:
            total = psutil.swap_memory().total
        except Exception, e:
            raise Exception(ErrorCode.GAUSS_505["GAUSS_50502"] + "Error: %s" % str(e))
        return total

    @staticmethod
    def getMemTotalSize():
        """
        function : Get system virtual memory total size
        input  : null
        output : total virtual memory(byte)
        """
        total = 0
        try:
            total = psutil.virtual_memory().total
        except Exception, e:
            raise Exception(ErrorCode.GAUSS_505["GAUSS_50502"] + "Error: %s" % str(e))
        return total
g_memory = memoryInfo()

