#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import commands
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckArchiveParameter(BaseItem):
    def __init__(self):
        super(CheckArchiveParameter, self).__init__(self.__class__.__name__)

    def doCheck(self):
        sqlcmd = "show archive_mode;"
        self.result.raw = sqlcmd

        output = SharedFuncs.runSqlCmd(sqlcmd, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile)
        if output.strip() == "on":
            sqlcmd = "show archive_command;"
            self.result.raw = sqlcmd
            output = SharedFuncs.runSqlCmd(sqlcmd, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile)
            cooInst = self.cluster.getDbNodeByName(self.host).coordinators[0]
            dataInst = self.cluster.getDbNodeByName(self.host).datanodes[0]
            if ((self.cluster.isSingleInstCluster() and not (output.find("%s" % dataInst.datadir) >= 0)) or not (output.find("%s" % cooInst.datadir) >= 0)):
                self.result.rst = ResultStatus.NG
            else:
                self.result.rst = ResultStatus.OK
        else:
            self.result.rst = ResultStatus.OK
        self.result.val = output

    def doSet(self):
        resultStr = ""
        cooInst = self.cluster.getDbNodeByName(self.host).coordinators[0]
        dataInst = self.cluster.getDbNodeByName(self.host).datanodes[0]
        if self.cluster.isSingleInstCluster():
            cmd = "gs_guc reload -N all -Z coordinator -I all -c \"archive_command = 'cp -P --remove-destination %s %s/pg_xlog/archive/%s'\" " % dataInst.datadir
        else:
            cmd = "gs_guc reload -N all -Z coordinator -I all -c \"archive_command = 'cp -P --remove-destination %s %s/pg_xlog/archive/%s'\"" % cooInst.datadir
        (status, output) = commands.getstatusoutput(cmd)
        if (status != 0):
            resultStr = "Failed to set ArchiveMode.\n Error : %s" %output
        else:
            resultStr = "Set ArchiveMode successfully."
        self.result.val = resultStr