#!/usr/bin/env python
# coding: UTF-8
try:
    import sys
    import time
    from datetime import datetime, timedelta
    from multiprocessing.dummy import Pool as ThreadPool
    reload(sys)
    sys.setdefaultencoding('utf-8')
    from gspylib.inspection.common import SharedFuncs
    from gspylib.common.Common import DefaultValue
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))

g_timieout = 60
g_retry = 3

class CheckDnWait(BaseItem):
    def __init__(self):
        super(CheckDnWait, self).__init__(self.__class__.__name__)

    def doCheck(self):
        dicHost = {}
        dicDN = {}
        dicDNCount = {}
        dnlist = []
        DN_HOST = {}
        CN_HOST = {}
        noMasterDNNode = []
        resultVal = ""
        tmpresult = ""
        dnName = ""
        hostName = ""
        totalWait = 0
        sqlgetCN = "select node_name  from pgxc_node where node_type='C';"
        sqlgetDNHost = "SELECT node_name, node_host FROM pgxc_node WHERE node_type='D' order by node_name;"
        sqlgetCNHost = "SELECT node_name, node_host FROM pgxc_node WHERE node_type='C' order by node_name;"
        sqlMonitorDN = """with para as \
         (select count(*) from pgxc_stat_activity where state = 'active' and usename != 'omm')
         select node, wait_num, query_num from (select query_id, node, sum(total_num)
         over(partition by node ) as wait_num, count(query_id) over(partition by node)
         as query_num, row_number() over(partition by node) as rownum
         from (select query_id, case when wait_status like 'wait node:%'
         then split_part(split_part(substr(wait_status, 12), ',', 1), '(', 1)
         when wait_status like 'flush data:%' then
         split_part(split_part(substr(wait_status, 13), ',', 1), '(', 1) end
         as node, sum(num) as total_num
         from (select query_id, wait_status, count(*) as num
         from pgxc_thread_wait_status where wait_status like 'wait node:%'
         or wait_status like 'flush data:%' group by 1, 2) group by 1, 2
         order by 3 desc)) where 3 * 4 * query_num > (select * from para)
         and rownum = 1 order by wait_num desc,  query_num desc
"""
        masterDnlist = SharedFuncs.getMasterDnNum(self.user, self.mpprcFile)
        datanode = None
        for dbNode in self.cluster.dbNodes:
            for datanode in dbNode.datanodes:
                if(datanode.instanceId in masterDnlist):
                    DN_HOST[datanode.instanceId] = datanode.hostname
        for dbNode in self.cluster.dbNodes:
            for cn in dbNode.coordinators:
                CN_HOST[str(cn.instanceId)] = datanode.hostname
        for dbNode in self.cluster.dbNodes:
            noMasterFlag = True
            for datanode in dbNode.datanodes:
                if (datanode.instanceId in masterDnlist):
                    noMasterFlag = False
            if (noMasterFlag):
                noMasterDNNode.append(dbNode)

        output = self.executeSqlWithRetry(sqlgetDNHost)
        if (output.startswith("ERROR") or output.startswith("TIMEOUT")):
            self.result.val = "%s %s" % (self.host, output)
            self.result.rst = ResultStatus.NG
            return
        for i in range(len(output.splitlines())-1):
            dnName, hostName = output.splitlines()[i].split('|')
            dnName = dnName.strip()
            hostName = hostName.strip()
            dnlist.append(dnName)
            for masterDn in masterDnlist:
                if(str(masterDn) in dnName):
                    hostName = DN_HOST[masterDn]
            if(hostName in dicHost.keys()):
                tmplist = dicHost[hostName]
                tmplist.append(dnName)
                dicHost[hostName] = tmplist
            else:
                dicHost[hostName] = [dnName]
        output = self.executeSqlWithRetry(sqlgetCNHost)
        if (output.startswith("ERROR") or output.startswith("TIMEOUT")):
            self.result.val = "%s %s" % (self.host, output)
            self.result.rst = ResultStatus.NG
            return
        for i in range(len(output.splitlines())):
            cnName, hostName = output.splitlines()[i].split('|')
            dnlist.append(cnName)
            if(hostName == "localhost"):
                hostName = DefaultValue.GetHostIpOrName()
            else:
                cmd = "grep '%s' /etc/hosts" % hostName
                tmpoutput = SharedFuncs.runShellCmd(cmd)
                for line in tmpoutput.splitlines():
                    hostName = line.split()[1]
            if (hostName in dicHost.keys()):
                tmplist = dicHost[hostName]
                tmplist.append(cnName)
                dicHost[hostName] = tmplist
            else:
                dicHost[hostName] = [cnName]
        try:
            outputCN = self.executeSqlWithRetry(sqlgetCN)
        except Exception as e:
            self.result.val = "%s %s" % (self.host, str(e))
            self.result.rst = ResultStatus.NG
            return
        if (outputCN.startswith("ERROR") or outputCN.startswith("TIMEOUT")):
            self.result.val = "%s %s" % (self.host, outputCN)
            self.result.rst = ResultStatus.NG
            return
        for cn in outputCN.splitlines():
            tmpsql = "execute direct on(%s) 'select wait_status from pg_thread_wait_status';" %(cn)
            try:
                output = self.executeSqlWithRetry(tmpsql)
            except Exception as e:
                self.result.val = "%s %s" % (self.host, str(e))
                self.result.rst = ResultStatus.NG
                return
            if (output.startswith("ERROR") or output.startswith("TIMEOUT")):
                self.result.val = "%s %s" % (CN_HOST[cn[3:]], output)
                self.result.rst = ResultStatus.NG
                return
            for line in output.splitlines():
                if(line.startswith("wait node:")):
                    tmpDn = line.split(",")[0].split(":")[1].strip()
                    if(tmpDn in dnlist):
                        totalWait += 1
                        if(tmpDn in dicDN.keys()):
                            dicDN[tmpDn] = dicDN[tmpDn] + 1
                        else:
                            dicDN[tmpDn] = 1

        try:
            outputMonitorDN = self.executeSqlWithRetry(sqlMonitorDN)
        except Exception as e:
            self.result.val = "%s %s" % (self.host, str(e))
            self.result.rst = ResultStatus.NG
            return
        if outputMonitorDN:
            for line in outputMonitorDN.splitlines():
                dnName = line.split("|")[0]
                count = line.split("|")[1]
                if dnName in dicDNCount.keys():
                    dicDNCount[dnName] += int(count)
                else:
                    dicDNCount[dnName] = int(count)

        if(totalWait > 0):
            for host, dnlist in dicHost.items():
                flag = False
                for dn in dnlist:
                    if(dn in dicDN.keys()):
                        flag =  True
                if(flag):
                    tmpresult += "%s " % (host)
                    tmplist = []
                    for dn in dnlist:
                        if(dn in dicDN.keys()):
                            tmplist.append("%s:%s" %(dn, dicDN[dn]))
                    tmpStr = ",".join(tmplist)
                    tmpresult += "%s\n" % tmpStr
        if(tmpresult):
            tmpresult = "monitor CN:\n%s" % tmpresult

        tmpDnResult = ""
        if dicDNCount:
            dnMapList = sorted(dicDNCount.items(), key=lambda item:item[1])
            if(len(dnMapList) > 8):
                dnMapList = dnMapList[-8:]
            for host, dnlist in dicHost.items():
                tmplist = []
                for dn, count in dnMapList:
                    if(dn in dnlist):
                        tmplist.append("%s:%s" %(dn, dicDNCount[dn]))
                if(tmplist):
                    tmpDnResult += "%s %s\n" % (host, ",".join(tmplist))
            if tmpDnResult:
                tmpresult += "\n monitor DN:\n%s" % tmpDnResult

        slaveDN = ""
        for dbNode in noMasterDNNode:
            tmplist = []
            wait = 0
            for datanode in dbNode.datanodes:
                for dnName in dicDN.keys():
                    if str(datanode.instanceId) in dnName:
                        tmpid = "dn_%s" % datanode.instanceId
                        tmplist.append("%s:%s" % (tmpid, dicDN[dnName]))
                        wait += dicDN[dnName]
            if wait:
                slaveDN += "%s %s\n" % (dbNode.name, ",".join(tmplist))
        if slaveDN:
            tmpresult += "\nmonitor SalveDN:\n%s" % slaveDN

        self.result.rst = ResultStatus.OK
        self.result.val = tmpresult

    def executeSqlWithRetry(self, sql):
        retry = 0
        excep = None
        while retry < g_retry:
            try:
                output = SharedFuncs.runSqlCmdWithTimeOut(sql, self.user, "", self.port, self.tmpPath,
                                                          "postgres", self.mpprcFile)
                return output
            except Exception as e:
                retry += 1
                excep = e
        raise Exception(str(excep))
