#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckHdfsForeignTabEncoding(BaseItem):
    def __init__(self):
        super(CheckHdfsForeignTabEncoding, self).__init__(self.__class__.__name__)

    def doCheck(self):
        databaseListSql = "select datname from pg_database where datname != 'template0';"
        sqlcmd = "show server_encoding;"
        dbList = SharedFuncs.runSqlCmd(databaseListSql, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile).split('\n')
        sqlPath = os.path.realpath(os.path.join(os.path.split(os.path.realpath(__file__))[0], "../../lib/checkblacklist/"))
        sqlFileName = os.path.join(sqlPath, "GetTable_unsupportHDFSForeignTable.sql")
        self.result.val = ""
        self.result.raw = ""
        failedFlag = False

        for dbname in dbList:
            result_str = ""
            #Check database encoding
            output = SharedFuncs.runSqlCmd(sqlcmd, self.user, "", self.port, self.tmpPath, dbname, self.mpprcFile)
            result_str += "\ndatabase[%s]\nserver_encoding: %s\n" % (dbname, output)
            self.result.raw += "\ndatabase[%s]: %s\n" % (dbname, output)
            if (output.strip().upper() not in ['LATIN-1','ISO-8859-1','SQL_ASCII']):
                #Check HDFS foreign table
                cmd = "gsql -m -d %s -p %s -f %s" % (dbname, self.port, sqlFileName)
                output = SharedFuncs.runShellCmd(cmd, self.user, self.mpprcFile)
                self.result.raw += "\n%s" % output
                if (output.find("0 rows") < 0):
                    tableList = output.split('\n')[:-2]
                    result_str += "HDFS foreign table:\n"
                    result_str += "\n".join(tableList)
                    self.result.val += result_str
                    failedFlag = True

        if (failedFlag):
            self.result.rst = ResultStatus.NG
        else:
            self.result.rst = ResultStatus.OK
