#!/usr/bin/env python
# coding: UTF-8
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    import json
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.common.Common import DefaultValue, ClusterCommand
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckTableSkew(BaseItem):
    def __init__(self):
        super(CheckTableSkew, self).__init__(self.__class__.__name__)

    def doCheck(self):
        flag = SharedFuncs.getFirstCNInstance(self.user, self.mpprcFile, self.tmpPath)
        dataDir = self.cluster.getDbNodeByName(DefaultValue.GetHostIpOrName()).cmagents[0].datadir
        security_mode_value = DefaultValue.getSecurityMode(dataDir)
        if (security_mode_value == "on"):
            DWS_Mode = True
        else:
            DWS_Mode = False
        if(flag or self.cluster.isSingleInstCluster()):
            if(DWS_Mode):
                finalresult =""
                dbList = []
                sqlList = []
                sqlPath = os.path.realpath(os.path.join(os.path.split(os.path.realpath(__file__))[0], "../../lib/checkblacklist/"))
                sqlFileName = os.path.join(sqlPath, "GetTableSkew.sql")
                fp = None
                if (os.path.exists(sqlFileName)):
                    try:
                        fp = open(sqlFileName, "r")
                        lines = fp.read()
                        sqlList = lines.split("--sqlblock")
                        sqlList.pop()
                    except Exception, e:
                        raise Exception("Unable to read file:%s,Error:%s" % (sqlFileName, str(e)))
                    finally:
                        if fp: fp.close()
                else:
                    raise Exception("Can't find sql file:%s" % sqlFileName)
                sqldb = "select datname from pg_database;"
                (status, result, error) = ClusterCommand.excuteSqlOnLocalhost(self.port, sqldb)
                if(status != 2):
                    raise Exception("Execute sql:%s failed. Error:%s" % (sqldb, error))
                recordsCount = len(result)
                for i in range(0, recordsCount):
                    dbList.append(result[i][0])
                dbList.remove("template0")
                dbList.remove("template1")
                for db in dbList:
                    schemaTable = []
                    for sql in sqlList:
                        sql = "set client_min_messages='error';\n" + sql
                        ClusterCommand.excuteSqlOnLocalhost(self.port, sql, db)
                    sql = "SELECT  schemaname , tablename FROM PUBLIC.pgxc_analyzed_skewness WHERE skewness_tuple > 100000;"
                    (status, result, error) = ClusterCommand.excuteSqlOnLocalhost(self.port, sql, db)
                    if(status !=2 ):
                        raise Exception("Execute sql:%s failed. Error:%s" % (sql, error))
                    else:
                        for i in range(len(result)):
                            schema = result[i][0]
                            table = result[i][1]
                            schemaTable.append("%s.%s" % (schema, table))
                    if(schemaTable):
                        finalresult += "%s:\n%s\n" %(db, "\n".join(schemaTable))
                if (finalresult):
                    self.result.rst = ResultStatus.WARNING
                    self.result.val = "The result is not ok:\n%s" % finalresult
                else:
                    self.result.rst = ResultStatus.OK
                    self.result.val = "Data is well distributed"
            else:
                finalresult = ""
                sqlPath = os.path.realpath(
                    os.path.join(os.path.split(os.path.realpath(__file__))[0], "../../lib/checkblacklist/"))
                sqlFileName = os.path.join(sqlPath, "GetTableSkew.sql")
                sqldb = "select datname from pg_database;"
                output = SharedFuncs.runSqlCmd(sqldb, self.user, "", self.port, self.tmpPath, "postgres",
                                               self.mpprcFile)
                dbList = output.split("\n")
                dbList.remove("template0")
                dbList.remove("template1")
                for db in dbList:
                    db = db.replace("$", "\\$")
                    cmd = "gsql -d %s -p %s -f %s" % (db, self.port, sqlFileName)
                    tmpout = ""
                    output = SharedFuncs.runShellCmd(cmd, self.user, self.mpprcFile)
                    if (output.find("(0 rows)") < 0):
                        tmpresult = output.splitlines()
                        idxS = ""
                        idxE = ""
                        for idx in range(len(tmpresult)):
                            if (not tmpresult[idx].find("---+---") < 0):
                                idxS = idx - 1
                            if (tmpresult[idx].find("row)") > 0 or tmpresult[idx].find("rows)") > 0):
                                idxE = idx
                        for i in range(idxS, idxE):
                            tmpout += "%s\n" % tmpresult[i]
                        finalresult += "%s:\n%s\n" % (db, tmpout)
                if (finalresult):
                    self.result.rst = ResultStatus.WARNING
                    self.result.val = "Data is not well distributed:\n%s" % finalresult
                else:
                    self.result.rst = ResultStatus.OK
                    self.result.val = "Data is well distributed"
        else:
            self.result.rst = ResultStatus.NA
            self.result.val = "First cn is not in this host"
