#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    import commands
    import platform
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.os.gsfile import g_file
    from gspylib.os.gsnetwork import g_network
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))

networkCards = []

class CheckBond(BaseItem):
    def __init__(self):
        super(CheckBond, self).__init__(self.__class__.__name__)

    def doCheck(self):
        global networkCards
        if (self.cluster):
            #Get node information
            LocalNodeInfo = self.cluster.getDbNodeByName(self.host)
            #Get the IP address
            serviceIP = LocalNodeInfo.backIps[0]
        elif (self.ipAddr):
            serviceIP = self.ipAddr
        else:
            serviceIP = SharedFuncs.getIpByHostName(self.host)
        networkCards = g_network.getAllNetworkInfo()
        for network in networkCards:
            if (network.ipAddress == serviceIP):
                networkCardNum = network.NICNum
                netBondMode = network.networkBondModeInfo
                break

        self.result.val = netBondMode
        self.result.rst = ResultStatus.OK
        self.result.raw = "%s\n%s\n" % (networkCardNum, netBondMode)
        
        bondFile = '/proc/net/bonding/%s' % networkCardNum
        if (os.path.exists(bondFile)):
            self.result.raw += bondFile
            flag1 = g_file.readFile(bondFile, 'BONDING_OPTS')
            flag2 = g_file.readFile(bondFile, 'BONDING_MODULE_OPTS')
            if (not flag1 and not flag2):
                self.result.rst = ResultStatus.NG
                self.result.val += "\nNo 'BONDING_OPTS' or 'BONDING_MODULE_OPTS' in bond config file[%s]." % bondFile

    def doSet(self):
        ifcfgFileSuse = "/etc/sysconfig/network/ifcfg-%s" % networkCards
        ifcfgFileRedhat = "/etc/sysconfig/network-scripts/ifcfg-%s" % networkCards
        distname, version, idnum = platform.dist()
        if (distname in ["redhat", "centos", "euleros", "oracle"]):
            cmd = "echo BONDING_MODULE_OPTS='mode=%d miimon=100 use_carrier=0' >> %s " % (1,ifcfgFileRedhat)
        else:
            cmd = "echo BONDING_MODULE_OPTS='mode=%d miimon=100 use_carrier=0' >> %s" % (1,ifcfgFileSuse)
        (status, output) = commands.getstatusoutput(cmd) 
        if (status != 0):
            self.result.val = "Filed to set bond mode.\n"
        else:
            self.result.val = "set bond mode successfully.\n"