#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import commands
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.os.gsnetwork import g_network
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))

networkCardNum = ""

class CheckMTU(BaseItem):
    def __init__(self):
        super(CheckMTU, self).__init__(self.__class__.__name__)
        self.expectMTU1 = None
        self.expectMTU2 = None

    def preCheck(self):
        # check current node contains cn instances if not raise  exception
        super(CheckMTU, self).preCheck()
        # check the threshold was set correctly
        if (not self.threshold.has_key('expectMTU1')):
            raise Exception("threshold expectMTU1 can not be empty")
        self.expectMTU1 = self.threshold['expectMTU1']
        if (not self.threshold.has_key('expectMTU2')):
            raise Exception("threshold expectMTU2 can not be empty")
        self.expectMTU2 = self.threshold['expectMTU2']

    def doCheck(self):
        global networkCardNum
        if (self.cluster):
            #Get node information
            LocalNodeInfo = self.cluster.getDbNodeByName(self.host)
            #Get the IP address
            backIP = LocalNodeInfo.backIps[0]
        else:
            backIP = SharedFuncs.getIpByHostName(self.host)
        #Get the network card number
        networkCards = g_network.getAllNetworkInfo()
        for network in networkCards:
            if (network.ipAddress == backIP):
                networkCardNum = network.NICNum
                networkMTU = network.MTUValue
                break
        if (not networkCardNum or not networkMTU):
            raise Exception("Failed to obtain network card information.")
        #Check the mtu value obtained is not a number
        if (not str(networkMTU).isdigit()):
            raise Exception("Failed to obtain network card [%s] MTU value." % networkCardNum)

        self.result.val = str(networkMTU)
        #Compare the acquired MTU with the threshold
        if (int(networkMTU) != int(self.expectMTU1) and int(networkMTU) != int(self.expectMTU2)):
            self.result.rst = ResultStatus.WARNING
            self.result.raw = "Warning MTU value[%s]: RealValue '%s' ExpectedValue '%s' or '%s'.\n" % (
                               networkCardNum, int(networkMTU), self.expectMTU1, self.expectMTU2)
        else:
            self.result.rst = ResultStatus.OK
            self.result.raw = "[%s]MTU: %s" % (networkCardNum, str(networkMTU))

    def doSet(self):
        resultStr = ""
        (THPFile, initFile) = SharedFuncs.getTHPandOSInitFile()
        cmd = "ifconfig %s mtu 1500;" % networkCardNum
        cmd += "echo ifconfig %s mtu 1500 >> %s" % (networkCardNum, initFile)
        (status,output) = commands.getstatusoutput(cmd)
        if (status != 0):
            resultStr += "Set MTU Filed.Error : %s." %output
        if (len(resultStr) > 0):
            self.result.val = resultStr
        else:
            self.result.val = "Set MTU successfully."


