#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    import commands
    import platform
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except Exception, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))

    
class CheckRouting(BaseItem):
    def __init__(self):
        super(CheckRouting, self).__init__(self.__class__.__name__)

    @staticmethod
    def getBinaryAddr(ipAddr):
        binaryStr = ""
        for part in ipAddr.split('.'):
            binaryStr += "%08d" % int(bin(int(part)).replace('0b', ''))
        return binaryStr

    def getBinaryRouting(self, ipAndMask):
        (ip, netMask) = ipAndMask.split(':')
        ipBinary = self.getBinaryAddr(ip)
        maskBinary = self.getBinaryAddr(netMask)
        routingBinary = ""
        if (not len(ipBinary) == len(maskBinary) == 32):
            return ""
        for bit in range(len(ipBinary)):
            routingBinary += str(int(ipBinary[bit]) & int(maskBinary[bit]))
        return routingBinary

    def doCheck(self):
        ipList = []
        routingBinary = self.getBinaryRouting(self.routing)
        if (SharedFuncs.isRedHat7()):
            cmd = "/sbin/ifconfig -a |grep -E '\<inet\>'| awk '{print $2}'"
        else:
            cmd = "/sbin/ifconfig -a |grep 'inet addr'| awk '{print $2}'| awk -F ':' '{print $2}'"
        output = SharedFuncs.runShellCmd(cmd)
        for eachLine in output.split('\n'):
            if (SharedFuncs.validate_ipv4(eachLine)):
                maskAddr = SharedFuncs.getMaskByIP(eachLine)
                ipMask = "%s:%s" % (eachLine, maskAddr)
                ipList.append(ipMask)
        self.result.raw = "Routing: %s [bit]%s\nlocalIP:\n%s" % (self.routing, routingBinary, "\n".join(ipList))

        commIP = []
        for ipMask in ipList:
            ipBinary = self.getBinaryRouting(ipMask)
            if (ipBinary == routingBinary):
                commIP.append(ipMask)

        if (len(commIP) > 1):
            self.result.rst = ResultStatus.WARNING
        else:
            self.result.rst = ResultStatus.OK
        self.result.val = "Business network segment IP: " + ", ".join(commIP)