#!/usr/bin/env python
# coding: UTF-8
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckBiggestTable(BaseItem):
    def __init__(self):
        super(CheckBiggestTable, self).__init__(self.__class__.__name__)

    def doCheck(self):
        sql = "SELECT n.nspname as Schema, c.relname as Name, pg_catalog.pg_get_userbyid(c.relowner) as Owner, pg_catalog.pg_table_size(c.oid) as Size FROM pg_catalog.pg_class c ,pg_catalog.pg_namespace n,pg_catalog.pgxc_class xc WHERE n.oid = c.relnamespace AND c.oid=xc.pcrelid order by 4 DESC LIMIT 1;"
        sqldb = "select datname from pg_database;"
        sqltenant = "select rolname as owner,datname as name,rolrespool as tenant from pg_database inner join pg_authid on datdba=pg_authid.oid;"
        output = SharedFuncs.runSqlCmd(sqldb, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile, self.name)
        dbList = output.split("\n")
        dbList.remove("template0")
        resultStr = ""
        dicowner = {}
        dictenant = {}
        output = SharedFuncs.runSqlCmd(sqltenant, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile,
                                       self.name)
        if(output):
            for info in output.splitlines():
                owner = info.split("|")[0]
                db = info.split("|")[1]
                tenant = info.split("|")[2]
                dicowner[db] = owner
                dictenant[db] = tenant
        for db in dbList:
            output = SharedFuncs.runSqlCmd(sql, self.user, "", self.port, self.tmpPath, db, self.mpprcFile, self.name)
            if(output):
                line = output.splitlines()[0]
                schema = line.split("|")[0]
                table = line.split("|")[1]
                size = line.split("|")[3]
                user = dicowner[db]
                tenant = dictenant[db]
                resultStr = "%s\nDatabase:%s Owner:%s Tenant:%s Table:%s.%s size:%s" %(resultStr, db, user, tenant, schema, table, size)
        self.result.rst = ResultStatus.OK
        self.result.val = resultStr
