#!/usr/bin/env python
#-*- coding:utf-8 -*-
try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import commands
    import platform
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.common.Common import DefaultValue
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckSctpService(BaseItem):
    def __init__(self):
        super(CheckSctpService, self).__init__(self.__class__.__name__)

    def doCheck(self):
        
        parRes = ""
        flag = "Normal"
        cmd = "ls -l /lib/modules/`uname -r`/kernel/net/sctp/sctp.ko*"
        (status, output) = commands.getstatusoutput(cmd)
        if(status != 0 or output == "" or output.find("No such file or directory") > 0):
            flag = "Error"
            parRes += "There is no sctp service."
        else:
            cmd = "modprobe sctp;"
            cmd += "lsmod |grep sctp"
            (status, output) = commands.getstatusoutput(cmd)
            if(output == ""):
                flag = "Error"
                parRes += "sctp service is not loaded."

        cmd = "cat %s | grep '^insmod.*sctp.ko'" % DefaultValue.getOSInitFile()
        (status, output) = commands.getstatusoutput(cmd)
        if(status != 0 or output == ""):
            if (flag == "Normal"):
                flag = "Warning"
            parRes += "Sctp service is not set to boot from power on."

        self.result.val = parRes
        self.result.raw = output
        if (flag == "Error"):
            self.result.rst = ResultStatus.NG
        elif (flag == "Warning"):
            self.result.rst = ResultStatus.WARNING
        else:
            self.result.rst = ResultStatus.OK
            self.result.val = "Sctp service is Normal."
            
    def doSet(self):
        self.result.val = ""
        parRes = ""
        sctpFile = ""
        initFileSuse = "/etc/init.d/boot.local"
        initFileRedhat = "/etc/rc.d/rc.local"
        cmd = "ls -l /lib/modules/`uname -r`/kernel/net/sctp/sctp.ko*"
        (status, output) = commands.getstatusoutput(cmd)
        if(status != 0 or output == "" or output.find("No such file or directory") > 0):
            parRes = "There is no sctp service.\n"
        else:
            sctpFile = output.split()[-1]
            cmd = "modprobe sctp;"    
            (status, output) = commands.getstatusoutput(cmd)
            if (status != 0):
                cmd = "insmod %s >/dev/null 2>&1;lsmod |grep sctp" % sctpFile
                (status, output) = commands.getstatusoutput(cmd)
                if status != 0 or output == "":
                    parRes = "Filed to load sctp service.\n"
        distname, version, idnum = platform.dist()
        if (distname in ["redhat", "centos", "euleros", "oracle"]):
            cmd = "cat %s | grep sctp" % initFileRedhat
            (status, output) = commands.getstatusoutput(cmd)
            if(status != 0 or output == ""):
                cmd = "echo 'modprobe sctp' >> /etc/rc.d/rc.local;"
                cmd += "echo 'insmod %s >/dev/null 2>&1' >> /etc/rc.d/rc.local " % sctpFile
                (status, output) = commands.getstatusoutput(cmd)
                if (status != 0):
                    parRes += "Filed to add sctp service to boot.\n"
        else:
            cmd = "cat %s | grep stcp" % initFileSuse
            (status, output) = commands.getstatusoutput(cmd)
            if(status != 0 or output == ""):
                cmd = "echo 'modprobe sctp' >> /etc/init.d/boot.local;"
                cmd += "echo '%s >/dev/null 2>&1' >> /etc/init.d/boot.local " % sctpFile
                (status, output) = commands.getstatusoutput(cmd)
                if (status != 0):
                    parRes += "Filed to add sctp service to boot."      
        self.result.val = parRes                    