#!/usr/bin/env python
#-*- coding:utf-8 -*-


try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.hardware.gsdisk import g_disk
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckDataDiskUsage(BaseItem):
    def __init__(self):
        super(CheckDataDiskUsage, self).__init__(self.__class__.__name__)

    def doCheck(self):
        flag = "Normal"
        resultStr = ""
        path_map = {}
        if (not self.cluster):
            self.result.rst = ResultStatus.NG
            self.result.val = "The datanode information is none."
            return

        for inst in self.cluster.getDbNodeByName(self.host).datanodes:
            path_map[inst.instanceId] = [inst.datadir]
        cnInstList = self.cluster.getDbNodeByName(self.host).coordinators
        if (len(cnInstList) > 0):
            tblspcDir = os.path.join(cnInstList[0].datadir, 'pg_tblspc')
            tblspcList = os.listdir(tblspcDir)
            if (tblspcList):
                path_map[cnInstList[0].instanceId] = []
                for tblspc in tblspcList:
                    tblspcPath = os.path.join(tblspcDir, tblspc)
                    if (os.path.islink(tblspcPath)):
                        path_map[cnInstList[0].instanceId].append(os.path.realpath(tblspcPath))

        for instanceId in path_map.keys():
            for path in path_map[instanceId]:
                rateNum = g_disk.getDiskSpaceUsage(path)
                self.result.raw += "[%s] space usage: %s%%\n" % (path, rateNum)
                if (rateNum > int(self.thresholdDn)):
                    resultStr += "%s %s %s space usage(%d%%)     Abnormal reason: The usage of the device disk space cannot be greater than %s%%.\n" % (
                                  instanceId, self.host, path, rateNum, self.thresholdDn)
                    flag = "Error"
                #Check inode usage
                diskName = g_disk.getMountPathByDataDir(path)
                diskType = g_disk.getDiskMountType(diskName)
                if (not diskType in ["xfs", "ext3", "ext4"]):
                    resultStr += "%s %s %s inodes usage(%s)     Warning reason: The file system type [%s] is unrecognized or not support. Please check it.\n" % (
                                      instanceId, self.host, path,  0, diskType)
                    if (flag == "Normal"):
                        flag = "Warning"
                    self.result.raw += "[%s] disk type: %s\n" % (path, diskType)
                    continue
                rateNum = g_disk.getDiskInodeUsage(path)
                self.result.raw += "[%s] inode usage: %s%%\n" % (path, rateNum)
                if (rateNum > int(self.thresholdDn)):
                    resultStr += "%s %s %s inode usage(%d%%)     Abnormal reason: The usage of the device disk inode cannot be greater than %s%%.\n" % (
                              instanceId, self.host, path, rateNum, self.thresholdDn)
                    flag = "Error"
        self.result.val = resultStr
        if (flag == "Normal"):
            self.result.rst = ResultStatus.OK
            self.result.val = "All disk space are sufficient.\n"
        else:
            self.result.rst = ResultStatus.NG