#!/usr/bin/env python
#-*- coding:utf-8 -*-


try:
    import sys
    reload(sys)
    sys.setdefaultencoding('utf-8')
    import os
    from gspylib.common.Common import DefaultValue
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
    from gspylib.hardware.gsdisk import g_disk
except ImportError, e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckLogDiskUsage(BaseItem):
    def __init__(self):
        super(CheckLogDiskUsage, self).__init__(self.__class__.__name__)

    def doCheck(self):
        flag = "Normal"
        path = DefaultValue.getEnv("GAUSSLOG", "/var/log/gaussdb/%s" % self.user)
        #Check space usage
        rateNum = g_disk.getDiskSpaceUsage(path)
        self.result.raw += "[%s] space usage: %s%%\n" % (path, rateNum)
        if (rateNum > int(self.thresholdDn)):
            self.result.val += "%s Path(%s) space usage(%d%%)     Abnormal reason: The usage of the device disk space cannot be greater than %s%%.\n" % (
                          self.host, path, rateNum, self.thresholdDn)
            flag = "Error"
        #Check inode usage
        diskName = g_disk.getMountPathByDataDir(path)
        diskType = g_disk.getDiskMountType(diskName)
        if (not diskType in ["xfs", "ext3", "ext4"]):
            self.result.val = "%s Path(%s) inodes usage(%s)     Warning reason: The file system type [%s] is unrecognized or not support. Please check it.\n" % (
                              self.host, path,  0, diskType)
            self.result.raw = "[%s] disk type: %s\n" % (path, diskType)
            self.result.rst = ResultStatus.WARNING
            return
        rateNum = g_disk.getDiskInodeUsage(path)
        self.result.raw += "[%s] inode usage: %s%%\n" % (path, rateNum)
        if (rateNum > int(self.thresholdDn)):
            self.result.val += "%s Path(%s) inode usage(%d%%)     Abnormal reason: The usage of the device disk inode cannot be greater than %s%%.\n" % (
                      self.host, path, rateNum, self.thresholdDn)
            flag = "Error"
        if (flag == "Normal"):
            self.result.rst = ResultStatus.OK
            self.result.val = "Log disk space are sufficient.\n"
        else:
            self.result.rst = ResultStatus.NG

