#!/usr/bin/env python
#-*- coding:utf-8 -*-
#############################################################################
#Copyright (c): 2012-2019, Huawei Tech. Co., Ltd.
#FileName     : ThreadPool.py
#Version      : Gauss200 
#Date         : 2018-04-10
#Description  : ThreadPool.py is utility to support parallel control by multiprocess
#############################################################################
try:
    import threading
    import multiprocessing
    import commands   
    import sys
    
    from multiprocessing.dummy import Pool as ThreadPool
except ImportError, e:
    sys.exit("[GAUSS-52200] : Unable to import module: %s." % str(e))
    
class parallelTool(object):
    '''
    Class for multi-parallel controling one-hosts
    '''
    DEFAULT_PARALLEL_NUM = 12


    def __init__(self):
        '''
        Constructor
        '''
    @staticmethod
    def getCpuCount(parallelJobs=0):
        """
        function: get cpu set of current board
                  cat /proc/cpuinfo |grep processor
        input: NA
        output: cpuSet
        """
        if (parallelJobs != 0):
            return parallelJobs
        # do this function to get the parallel number
        cpuSet = multiprocessing.cpu_count()
        if (cpuSet > 1):
            return cpuSet
        else:
            return parallelTool.DEFAULT_PARALLEL_NUM
        
    @staticmethod
    def parallelExecute(func, paraList, parallelJobs=0, isMap=False):
        """
        function: Execution of python functions through multiple processes
        input: func, list
        output: list
        """
        resultMap = {}
        jobs = parallelTool.getCpuCount(parallelJobs)
        if (jobs > len(paraList)):
            jobs = len(paraList)
        pool = ThreadPool(jobs)
        results = pool.map(func, paraList)
        pool.close()
        pool.join()
        if isMap:
            for result in results:
                resultMap[result[0]] = result[1]
            return resultMap
        return results
    
class CommandThread(threading.Thread):
    """
    The class is used to execute command in thread
    """
    def __init__(self, cmd):
        '''
        Constructor
        ''' 
        threading.Thread.__init__(self)
        self.command = cmd
        self.cmdStauts = 0
        self.cmdOutput = ""
        
    def run(self):
        """
        function: Run command
        input : NA
        output: NA
        """
        (self.cmdStauts, self.cmdOutput) = commands.getstatusoutput(self.command)
